<template>
  <div class="q-pa-md">
    <div>
      <h1>  Upload Asset File </h1>
           <div class="row">
              <div class="col-sm-3 col-12 text-black" style="max-width: 350px">
                <q-uploader
                  url='http://127.0.0.1:5000/assets'
                  method="PUT"
                  label="Upload file"
                  color="light-green-2"
                  text-color="black"
                  flat
                  accept=".csv"
                  bordered
                  style="max-width: 300px"
                  field-name="assets"
                  @uploaded="atUploaded"
                  @failed="atFailed"
                />
            </div>

            <div class="col-sm-1 col-12"></div>

            <div class="col-sm-5 col-12" style="max-width: 525px">
              <q-banner rounded dense class="bg-light-green-2 text-black q-pa-md" >
                <b>Each line of the .csv file MUST be in format:  </b><i><span class="red">Name|Polled IP Address|Location|Serial Number|Manufacturer|Model|Firmware Version</span></i>
                <ul>
                  <li>the values MUST appear in the order presented above</li>
                  <li>"Cisco" must be in "Manufacturer" field in order for an asset to be imported.</li>
                </ul>
                <template v-slot:action>
                  <q-chip
                    dense
                    clickable
                    @click="downloadFile('givemeanexample.csv')"
                    icon="save_alt"
                    color="green">
                    Get example file
                  </q-chip>
                </template>
              </q-banner>
            </div>

            <div class="row">
              <div class="col-sm-3 col-12 text-white">
                <span >. </span>
              </div>
            </div>
         </div>
      </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      domainId: null,
      file: null
    }
  },
  methods: {
    notify(message, icon = 'check') {
      this.$q.notify({icon, position: 'top', message})
    },
    atUploaded(){
      this.$q.dialog({
        title: 'Info',
        message: 'File Successfully Uploaded'
      }).onOk(() => {
        window.location.reload()
      })
    },
    atFailed(){
      this.$q.dialog({
        title: 'WARNING!!!',
        message: 'Upload operation FAILED',
        color: 'red',
        dark: true
      }).onOk(() => {
        // window.location.reload()
      })
    },
    downloadFile(fileName){
      this.$axios({
        method: 'get',
        url: `/download/${fileName}`,
        responseType: 'arraybuffer'
      })
        .then(response => {

          this.forceFileDownload(response, fileName)

        })
        .catch(() => console.log('error occured'))
    },
    forceFileDownload(response, fileName){
      const url = window.URL.createObjectURL(new Blob([response.data]))
      const link = document.createElement('a')
      link.href = url
      link.setAttribute('download', fileName) //or any other extension
      document.body.appendChild(link)
      link.click()
    }
  }
}
</script>

<style lang="stylus">
  h1
    font-size 1.5rem
    line-height 2rem

  h2
    font-size 0.9rem
    line-height 2rem

  .actions
    margin-top 20px

  .info
    background-color rgb(247, 232, 236)

  .q-chip--dense
    font-size 14px

  .red {
    color: #2a9f1c;
  }
</style>
